/**
 * Wraps the standalone.js file generated by the 
 * browserify call with prefix.txt and suffix.txt.
 * The end result is a file that assumes that 
 * backbone and underscore are in the global namespace
 * and does not require browserify to work.
*/


var fs = require('fs');


// Retrieve contents of prefix, suffix, and tabled.js files
var prefix = fs.readFileSync(__dirname + '/prefix.txt');
var suffix = fs.readFileSync(__dirname + '/suffix.txt');
var inner = fs.readFileSync(__dirname  + '/tabled.js');

// Wrap the file
var wrapped = prefix + inner + suffix;

// Replace tabled.js with the wrapped string
fs.writeFileSync(__dirname + '/tabled.js', wrapped);